# Uncertainty-engine-resource-client
Resource management API for the twinLab platform.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0
- Package version: 1.0.0
- Generator version: 7.12.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://www.digilab.co.uk/](https://www.digilab.co.uk/)

To regenerate the package, use the `openapi-generator-cli` tool with the configuration file defined in this repository:

```bash
# Install dependencies
poetry install
```

```bash
# Generate the client
poetry run openapi-generator-cli generate -c openapi-generator-config.yaml
```

This should only alter files that have been modified since the last generation. If you want to regenerate everything, you can delete the `openapi-generator` directory and run the command again.

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/digiLab-ai/uncertainty-engine-resource-client.git
```


Then import the package:
```python
import uncertainty_engine_resource_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import uncertainty_engine_resource_client
from uncertainty_engine_resource_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://tu8vus047g.execute-api.eu-west-2.amazonaws.com
# See configuration.py for a list of all supported configuration parameters.
configuration = uncertainty_engine_resource_client.Configuration(
    host = "https://tu8vus047g.execute-api.eu-west-2.amazonaws.com"
)



# Enter a context with an instance of the API client
with uncertainty_engine_resource_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = uncertainty_engine_resource_client.AccountRecordsApi(api_client)
    account_id = 'account_id_example' # str | 

    try:
        # Delete Account Record
        api_response = api_instance.delete_account_record(account_id)
        print("The response of AccountRecordsApi->delete_account_record:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AccountRecordsApi->delete_account_record: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://tu8vus047g.execute-api.eu-west-2.amazonaws.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccountRecordsApi* | [**delete_account_record**](docs/AccountRecordsApi.md#delete_account_record) | **DELETE** /api/accounts/{account_id} | Delete Account Record
*AccountRecordsApi* | [**get_account_record**](docs/AccountRecordsApi.md#get_account_record) | **GET** /api/accounts/{account_id} | Get Account Record Id
*AccountRecordsApi* | [**get_account_record_projects**](docs/AccountRecordsApi.md#get_account_record_projects) | **GET** /api/accounts/{account_id}/projects | Get Account Record Projects
*AccountRecordsApi* | [**post_account_record**](docs/AccountRecordsApi.md#post_account_record) | **POST** /api/accounts | Post Account Record
*AuthApi* | [**get_tokens**](docs/AuthApi.md#get_tokens) | **POST** /api/auth/token | Get Tokens
*AuthApi* | [**refresh_token**](docs/AuthApi.md#refresh_token) | **POST** /api/auth/refresh | Refresh Token
*ProjectRecordsApi* | [**delete_project_record**](docs/ProjectRecordsApi.md#delete_project_record) | **DELETE** /api/projects/{project_id} | Delete Project Record
*ProjectRecordsApi* | [**get_project_record_id**](docs/ProjectRecordsApi.md#get_project_record_id) | **GET** /api/projects/{project_id} | Get Project Record Id
*ProjectRecordsApi* | [**post_project_record**](docs/ProjectRecordsApi.md#post_project_record) | **POST** /api/projects | Post Project Record
*ResourcesApi* | [**delete_resource_record**](docs/ResourcesApi.md#delete_resource_record) | **DELETE** /api/projects/{project_id}/resources/{resource_type}/{resource_id} | Delete Resource
*ResourcesApi* | [**delete_resource_version_record**](docs/ResourcesApi.md#delete_resource_version_record) | **DELETE** /api/projects/{project_id}/resources/{resource_type}/{resource_id}/versions/{resource_version_id} | Delete Resource Version
*ResourcesApi* | [**get_latest_resource_version**](docs/ResourcesApi.md#get_latest_resource_version) | **GET** /api/projects/{project_id}/resources/{resource_type}/{resource_id}/latest | Get Latest Resource Version
*ResourcesApi* | [**get_project_resource_records**](docs/ResourcesApi.md#get_project_resource_records) | **GET** /api/projects/{project_id}/resources/{resource_type} | Get Project Resource Records
*ResourcesApi* | [**get_resource_record**](docs/ResourcesApi.md#get_resource_record) | **GET** /api/projects/{project_id}/resources/{resource_type}/{resource_id} | Get Resource Record
*ResourcesApi* | [**get_resource_version**](docs/ResourcesApi.md#get_resource_version) | **GET** /api/projects/{project_id}/resources/{resource_type}/{resource_id}/versions/{resource_version_id} | Get Resource Version
*ResourcesApi* | [**get_resource_version_records**](docs/ResourcesApi.md#get_resource_version_records) | **GET** /api/projects/{project_id}/resources/{resource_type}/{resource_id}/versions | Get Resource Version Records
*ResourcesApi* | [**patch_resource_version**](docs/ResourcesApi.md#patch_resource_version) | **PATCH** /api/projects/{project_id}/resources/{resource_type}/{resource_id}/versions/{resource_version_id} | Patch Resource Version
*ResourcesApi* | [**post_resource_record**](docs/ResourcesApi.md#post_resource_record) | **POST** /api/projects/{project_id}/resources/{resource_type} | Post Resource Record
*ResourcesApi* | [**post_resource_version**](docs/ResourcesApi.md#post_resource_version) | **POST** /api/projects/{project_id}/resources/{resource_type}/{resource_id}/versions | Post Resource Version
*ResourcesApi* | [**put_upload_resource_version**](docs/ResourcesApi.md#put_upload_resource_version) | **PUT** /api/projects/{project_id}/resources/{resource_type}/{resource_id}/pending/{pending_record_id} | Put Upload Resource Version
*TemplatesApi* | [**delete_workflow_template**](docs/TemplatesApi.md#delete_workflow_template) | **DELETE** /api/templates/workflows/{workflow_template_id} | Delete Workflow Template
*TemplatesApi* | [**get_workflow_template_record**](docs/TemplatesApi.md#get_workflow_template_record) | **GET** /api/templates/workflows/{workflow_template_id} | Get Workflow Template
*TemplatesApi* | [**get_workflow_template_records**](docs/TemplatesApi.md#get_workflow_template_records) | **GET** /api/templates/workflows | Get Workflow Templates
*TemplatesApi* | [**workflow_template**](docs/TemplatesApi.md#workflow_template) | **POST** /api/templates/workflows | Workflow Template
*WorkflowsApi* | [**delete_workflow_record**](docs/WorkflowsApi.md#delete_workflow_record) | **DELETE** /api/projects/{project_id}/workflows/{workflow_id} | Delete Workflow
*WorkflowsApi* | [**delete_workflow_version_record**](docs/WorkflowsApi.md#delete_workflow_version_record) | **DELETE** /api/projects/{project_id}/workflows/{workflow_id}/versions/{workflow_version_id} | Delete Workflow Version
*WorkflowsApi* | [**get_latest_workflow_version**](docs/WorkflowsApi.md#get_latest_workflow_version) | **GET** /api/projects/{project_id}/workflows/{workflow_id}/latest | Get Latest Workflow Version
*WorkflowsApi* | [**get_project_workflow_records**](docs/WorkflowsApi.md#get_project_workflow_records) | **GET** /api/projects/{project_id}/workflows | Get Project Workflow Records
*WorkflowsApi* | [**get_workflow_record**](docs/WorkflowsApi.md#get_workflow_record) | **GET** /api/projects/{project_id}/workflows/{workflow_id} | Get Workflow Record
*WorkflowsApi* | [**get_workflow_version**](docs/WorkflowsApi.md#get_workflow_version) | **GET** /api/projects/{project_id}/workflows/{workflow_id}/versions/{workflow_version_id} | Get Workflow Version
*WorkflowsApi* | [**get_workflow_version_records**](docs/WorkflowsApi.md#get_workflow_version_records) | **GET** /api/projects/{project_id}/workflows/{workflow_id}/versions | Get Workflow Version Records
*WorkflowsApi* | [**post_workflow_record**](docs/WorkflowsApi.md#post_workflow_record) | **POST** /api/projects/{project_id}/workflows | Post Workflow Record
*WorkflowsApi* | [**post_workflow_version**](docs/WorkflowsApi.md#post_workflow_version) | **POST** /api/projects/{project_id}/workflows/{workflow_id}/versions | Post Workflow Version
*WorkflowsApi* | [**put_workflow_version**](docs/WorkflowsApi.md#put_workflow_version) | **PUT** /api/projects/{project_id}/workflows/{workflow_id}/versions/{workflow_version_id} | Put Workflow Version
*DefaultApi* | [**health_health_get**](docs/DefaultApi.md#health_health_get) | **GET** /health | Health


## Documentation For Models

 - [AccountRecordInput](docs/AccountRecordInput.md)
 - [AccountRecordOutput](docs/AccountRecordOutput.md)
 - [AccountResponse](docs/AccountResponse.md)
 - [GetAccountRecordProjectsResponse](docs/GetAccountRecordProjectsResponse.md)
 - [GetResourceRecordsResponse](docs/GetResourceRecordsResponse.md)
 - [GetResourceVersionRecordsResponse](docs/GetResourceVersionRecordsResponse.md)
 - [GetResourceVersionResponse](docs/GetResourceVersionResponse.md)
 - [GetWorkflowRecordsResponse](docs/GetWorkflowRecordsResponse.md)
 - [GetWorkflowTemplateRecordsResponse](docs/GetWorkflowTemplateRecordsResponse.md)
 - [GetWorkflowVersionRecordsResponse](docs/GetWorkflowVersionRecordsResponse.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [PatchResourceVersionRequest](docs/PatchResourceVersionRequest.md)
 - [PostAccountRecordRequest](docs/PostAccountRecordRequest.md)
 - [PostProjectRecordRequest](docs/PostProjectRecordRequest.md)
 - [PostResourceRecordRequest](docs/PostResourceRecordRequest.md)
 - [PostResourceVersionRequest](docs/PostResourceVersionRequest.md)
 - [PostResourceVersionResponse](docs/PostResourceVersionResponse.md)
 - [PostWorkflowRecordRequest](docs/PostWorkflowRecordRequest.md)
 - [PostWorkflowTemplateRecordRequest](docs/PostWorkflowTemplateRecordRequest.md)
 - [PostWorkflowVersionRequest](docs/PostWorkflowVersionRequest.md)
 - [ProjectRecordInput](docs/ProjectRecordInput.md)
 - [ProjectRecordOutput](docs/ProjectRecordOutput.md)
 - [ProjectResponse](docs/ProjectResponse.md)
 - [ProjectRoles](docs/ProjectRoles.md)
 - [ResourceLocation](docs/ResourceLocation.md)
 - [ResourceRecordInput](docs/ResourceRecordInput.md)
 - [ResourceRecordOutput](docs/ResourceRecordOutput.md)
 - [ResourceResponse](docs/ResourceResponse.md)
 - [ResourceVersionRecordInput](docs/ResourceVersionRecordInput.md)
 - [ResourceVersionRecordOutput](docs/ResourceVersionRecordOutput.md)
 - [TokenResponse](docs/TokenResponse.md)
 - [UpdateWorkflowVersionRequest](docs/UpdateWorkflowVersionRequest.md)
 - [ValidationError](docs/ValidationError.md)
 - [ValidationErrorLocInner](docs/ValidationErrorLocInner.md)
 - [WorkflowRecordInput](docs/WorkflowRecordInput.md)
 - [WorkflowRecordOutput](docs/WorkflowRecordOutput.md)
 - [WorkflowResponse](docs/WorkflowResponse.md)
 - [WorkflowTemplateRecordInput](docs/WorkflowTemplateRecordInput.md)
 - [WorkflowTemplateRecordOutput](docs/WorkflowTemplateRecordOutput.md)
 - [WorkflowTemplateResponse](docs/WorkflowTemplateResponse.md)
 - [WorkflowVersionRecordInput](docs/WorkflowVersionRecordInput.md)
 - [WorkflowVersionRecordOutput](docs/WorkflowVersionRecordOutput.md)
 - [WorkflowVersionResponse](docs/WorkflowVersionResponse.md)





